# About Frontend at Smarter.Codes

|                  | Where we are                                                                                                                                                                                                                                                                     | Where we want to be                                                                                         | How do we get there                                                                                         |
| ---------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------- |
| People | We have a good number of BE heavy engineers at Smarter.Codes, but where we lack are the following departments :- <br> 1. [UI developers](https://gitlab.com/smarter-codes/guidelines/software-engineering/hiring/-/issues/3) <br> 2. [FE heavy full-stack engineers](https://gitlab.com/smarter-codes/guidelines/software-engineering/hiring/-/issues/4). | We want to have a team that is equally proficient in UI, Frontend, Backend and DevOps tasks.  | We explode the role of [Full-Stack engineer](https://gitlab.com/smarter-codes/guidelines/software-engineering/hiring/-/issues/1) at Smarter.Codes into :- <br> 1. FE heavy full-stack engineers <br> 2. BE heavy full-stack engineers <br> 3. UI engineers |
| Guidelines       | For Frontend guidelines, we have guidelines projects that cover [general frontend issues](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/about-frontend/-/issues) and we also have tech specific guideline projects for [Javascript](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/javascript), [React](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/frameworks/reactjs) etc.                                                                                                                                                                   | 1. Have in depth guideline issues for the already created projects. <br> 2. We need to have issues maintained for UX architectures, projects for CSS/SCSS and [frontend performance](https://www.smashingmagazine.com/2021/01/front-end-performance-2021-free-pdf-checklist/). | Need more contribution to existing guidelines and also need people (either current engineers or new recruitment) who take up maintaining issues specifically for UI&UX issues. |
| Work             | At Smarter.Codes, our FE projects are mostly on React, Vue and Wordpress. We don't have experience with [PWAs, Mobile apps or desktop apps](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/about-frontend/-/issues/11).                                                                                                                                                                       | We would like to have FE projects divided based on [Web applications, mobile applications and Dekstop applications](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/about-frontend/-/issues/12). | This would need the current engineers to be upskilled in PWAs, server-side rendering etc. and new mobile and desktop developers(If we are planning to go down those lines as well). |
|Boilerplates |We do not currently have any boilerplate for any of the frameworks or CSS architectures to be used in the FE. | We wish to have pre-defined and extensible boilerplates for frameworks like [Vue](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/frameworks/vuejs/boilerplate), [React](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/frameworks/reactjs/boilerplate) etc.  |  Need work towards having agreed upon boilerplates for the different frameworks used at Smarter.Codes.  |
|People | Currently, all the engineers at Smarter.Codes do not have FE or UI development skillset or at least working knowledge of the same. | We want the current full-stack engineers at Smarter.Codes to have at least working knowledge of UI development. This is to move towards our goal of having [T-shaped](https://jchyip.medium.com/why-t-shaped-people-e8706198e437) engineers at Smarter.Codes | We would want every engineer (mainly BE heavy) to [upskill themselves](https://gitlab.com/smarter-codes/guidelines/software-engineering/coding/frontend/about-frontend/-/issues/7) to have some knowledge of HTML, CSS and other UI development. |

# TODO

- Explore [Front-End Developers Have to Manage the Loading Experience](https://css-tricks.com/front-end-developers-have-to-manage-the-loading-experience/) and create guidelines and projects inspired from there

# Inspirations
* [Front-end Performance Checklist 2021](https://www.smashingmagazine.com/2021/01/front-end-performance-2021-free-pdf-checklist/)
